/* Copyright (C) 2005, 2006, 2007, 2008, 2009 Stefan Frenz
 * 
 * This file is part of SJC, the Small Java Compiler written by Stefan Frenz.
 * 
 * SJC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SJC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with SJC. If not, see <http://www.gnu.org/licenses/>.
 */

package frontend.binimp;

import compbase.*;

/**
 * BImExpr: dummy expression pointing to binary imported data
 * 
 * @author S. Frenz
 * @version 090724 adopted changed Expr
 *  version 090207 added copyright notice
 *  version 070909 optimized signature of Expr.resolve
 *  version 070727 replaced exSubResolve by resolve as there is nothing done anymore
 *  version 070511 optimized by moving functionallity to Importer 
 *  version 070114 reduced access level where possible
 *  version 070111 adapted change in printPos and compErr
 *  version 070106 removed genOutputAddr
 *  version 061203 optimized calls to printPos and compErr
 *  version 061202 adopted changed interface of Expr
 *  version 061128 added support for embedded mode
 *  version 060607 initial version
 */

public class BImExpr extends ExAccVrbl {
  protected byte[] data;
  protected Vrbl target;
  
  protected BImExpr(byte[] id, Vrbl var, int fid) {
    super(fid, -1, -1);
    data=id;
  }
  
  public boolean resolve(Unit unitContext, Mthd mthdContext, boolean checkRead, boolean insideLoop, Context ctx) {
    //nothing to do
    return true;
  }
  
  public Vrbl getCompInitConstObjectVrbl(Context ctx) {
    return target;
  }
  
  public void genOutputVal(int reg, Context ctx) {
    compErr(ctx, "BImExpr.genOutputVal not supported");
  }
}
